<?php
/**
2vx.inc.php by Rodrigo Severo
2svx.inc.php is a support file for both mnemo2svx.php and tml2svx.php.
Both convert MNemo generated data to Survex format.

Copyright (C) 2021  Rodrigo Severo <rsev@pm.me>

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

function slugify($text, string $divider = '_')
{
  // replace non letter or digits by divider
  $text = preg_replace('~[^\pL\d]+~u', $divider, $text);

  // transliterate
  $text = iconv('utf-8', 'us-ascii//TRANSLIT', $text);

  // remove unwanted characters
  $text = preg_replace('~[^-\w]+~', '', $text);

  // trim
  $text = trim($text, $divider);

  // remove duplicate divider
  $text = preg_replace('~-+~', $divider, $text);

  // lowercase
  // $text = strtolower($text);

  if (empty($text)) {
    return 'n-a';
  }

  return $text;
}

function new_line($text, $prefix) {
  $new_line = sprintf("%s%s\n", $prefix, $text);

  return $new_line;
}

function date_in_svx_format($date) {
  $date = date_create($date);
  $date = date_format($date, 'Y.m.d');

  return $date;
}
